/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "ClientMainMenu.hpp"

ClientMainMenu::ClientMainMenu(UI_Menu* uim, UnitContainer* uc, PLAYER p){
    myui = uim;
    display = uim;
    units = uc;
    plyr = p;

    item.push_back(new MenuItem("Menu", HEADLINE));
    item.push_back(new MenuItem("Prev Unit", ENABLED));
    item.push_back(new MenuItem("Next Unit", ENABLED));
    item.push_back(new MenuItem("Cancel Commands", ENABLED));
    item.push_back(new MenuItem("Clear Report", ENABLED));
    item.push_back(new MenuItem("End Turn", SELECTED));
    selectItem(5);
}

ClientMainMenu::~ClientMainMenu(){
    clear();
}

void ClientMainMenu::runItem(unsigned int itemno, int){
    switch (itemno){
    case 1:
        do {
            units->selectPrevUnit(NOUNIT,plyr);
        } while ( units->getSelectedUnit() == NULL );
        currinput = SELECTUNIT;
        break;
    case 2:
        do {
            units->selectNextUnit(NOUNIT,plyr);
        } while ( units->getSelectedUnit() == NULL );
        currinput = SELECTUNIT;
        break;
    case 3:
        units->getSelectedUnit()->clearCommands();
        currinput = ORDER;
        break;
    case 4:
        units->tidy();
        currinput = TIDY;
        break;
    case 5:
        currinput = ENDROUND;
        break;
    default:
        break;
    }
}
