/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "StartGameMenu.hpp"

StartGameMenu::StartGameMenu(UI_Menu* uim){
    myui = uim;
    display = uim;

    selectedmap = "icu.map";
    item.push_back(new MenuItem("Choose Map", HEADLINE));
    item.push_back(new MenuItem("Start " + selectedmap, SELECTED));
    item.push_back(new MenuItem("Armada", ENABLED));
    item.push_back(new MenuItem("Bridgebuilder", ENABLED));
    item.push_back(new MenuItem("Reinforcements", ENABLED));
    item.push_back(new MenuItem("I C U", ENABLED));
    item.push_back(new MenuItem("Continue last Game", ENABLED));
    item.push_back(new MenuItem("Back", ENABLED));
    selectItem(1);
}

StartGameMenu::~StartGameMenu(){
    clear();
}

void StartGameMenu::runItem(unsigned int itemno, int){
    switch (itemno){
    case 1:
        currinput = START;
        break;
    case 2:
        selectedmap = "armada.map";
        break;
    case 3:
        selectedmap = "bridge.map";
        break;
    case 4:
        selectedmap = "reinforce.map";
        break;
    case 5:
        selectedmap = "icu.map";
        break;
    case 6:
        currinput = CONTINUEGAME;
        break;
    case 7:
        currinput = QUIT;
        break;
    default:
        break;
    }
    if( currinput == MENUSELECT ){
        delete item[1];
        item[1] = new MenuItem("Start " + selectedmap, ENABLED);
        refresh();
    }
}

std::string StartGameMenu::getSelectedMap(){
    return selectedmap;
}
