/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "MainMenu.hpp"

MainMenu::MainMenu(UI_Menu* uim, Lobby* lby){
    display = uim;
    myui = uim;
    lobby = lby;
    item.push_back(new MenuItem("Main Menu", HEADLINE));
    item.push_back(new MenuItem("Hot Seat", SELECTED));
    item.push_back(new MenuItem("Editor", ENABLED));
    item.push_back(new MenuItem("Configuration", ENABLED));
    item.push_back(new MenuItem("Quit", ENABLED));
    selectItem(1);
}

MainMenu::~MainMenu(){
    clear();
}

void MainMenu::runItem(unsigned int itemno, int){
    switch (itemno){
    case 1:
        lobby->setNextRunMode(HOTSEAT);
        break;
    case 2:
        lobby->setNextRunMode(EDITOR);
        break;
    case 3:
        lobby->changeMenu(CONFIGMENU);
        break;
    case 4:
        lobby->changeMenu(QUITMENU);
        break;
    default:
        break;
    }
}

