/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2012  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <iostream>

#include "FSHandler.hpp"
#include "../misc/Exceptions.hpp"

int main(int argc, char** argv) {
#ifndef ALLEGRO4
    al_init();
#endif

    FSHandler* fsh = new FSHandler();
    try {
        std::cout << "Searching \"maps/icu.map\"... \n\t";
        std::cout << "First hit at: "
                  << fsh->getFullPath(PathName("maps/icu.map")).string()
                  << std::endl;
        std::cout << "Searching \"foo.invalid\"... "
                  << "(An error message should follow.)\n\t";
        std::cout << "First hit at: "
                  << fsh->getFullPath(PathName("foo.invalid")).string()
                  << std::endl;
    } catch( Hexception& e) {
        std::cerr << e.what();
    }

    std::cout << "Contdir: \t"  << fsh->getContDir().string()      << std::endl;
    std::cout << "Exedir: \t"   << fsh->getExeDir().string()       << std::endl;
    std::cout << "Settings: \t" << fsh->getSettingsDir().string()  << std::endl;
    std::cout << "Homedir: \t"  << fsh->getHomeDir().string()      << std::endl;

    delete fsh;

    return 0;
}
