/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <iostream>
#include <iomanip>

#include "PathName.hpp"

void printPath(std::string description, PathName printme){
    std::cout << description << ": " << std::left << std::setw(5) << printme.string() << "\t";
}

int main(){
#ifdef ALLEGRO5
    al_init();
#endif

    PathName a = "a";
    PathName b = "b";
    PathName c = "c";
    PathName* d = new PathName(c);
    c /= "f/g";
    printPath("a", a);printPath("b", b);printPath("c", c);
    std::cout << "d: " << d->string() << std::endl;
    a /= c;
    c /= b;
    b /= *d;
    d->operator /=("e");
    printPath("a", a);printPath("b", b);printPath("c", c);
    std::cout << "d: " << d->string() << std::endl;

    delete d;

#ifdef ALLEGRO5
    al_uninstall_system();
#endif

    return 0;
}
