/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef BST_PATHNAME_HPP
#define BST_PATHNAME_HPP

#include <string>
#include <boost/filesystem.hpp>

#include "../PathName.hpp"

namespace fs = boost::filesystem;

class BstPathName : public VirtualPathName {
public:
    BstPathName();
    BstPathName(const char*);
    BstPathName(std::string);
    BstPathName(const BstPathName&);
    BstPathName(fs::path);
    ~BstPathName();

    std::string string();
    const char* c_str();
    fs::path bstPath();

    bool exists();

    BstPathName operator=(const char*);
    BstPathName operator=(BstPathName);

    BstPathName operator/=(const char*);
    BstPathName operator/=(std::string);
    BstPathName operator/=(BstPathName);

    BstPathName operator/(const char*);

protected:
    void append(const char*);
    void append(std::string);

    void setPathName(const char*);
    void setPathName(std::string);
    void setPathName(fs::path path);

private:
    fs::path name;
};

#endif // BST_PATHNAME_HPP
