/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef UI_HPP
#define UI_HPP

typedef unsigned int INPUTTYPE;
/**
 * NOINPUT: nothing happened
 * LMB: left mouse button klicked
 * RMB: right mouse button clicked
 * MMB: middle mouse button clicked
 * LMBHOLD: left mouse button not released
 * RMBHOLD: right mouse button not released
 * UP: uparrow hit
 * DOWN: downarrow hit
 * SCROLL: scrolled the map or changed item in a menu
 * SELECT: selected something (to be run instantly)
 * QAl5UIT: qAl5UIt the game or wharever
 * ENDROUND: end a round
 * MOVEMENU: changed the position of a movable menu
 * SWITCHPLAYER: initialize switching players
 * SWITCH2P1: active player is switched to PLAYER1
 * SWITCH2P1: active player is switched to PLAYER2
 */
enum Inputtypes{
    NOINPUT=0, QUIT=1, TIME=3, LMB, LMBHOLD, RMB, RMBHOLD, MMB, MMBHOLD,
    ENDROUND, MOVEMENU, UP, DOWN, LEFT, RIGHT, HOVER, SAVE, SWITCHPLAYER,
    SWITCH2P1, SWITCH2P2, KP1, KP2, KP3, KP4, KP5, KP6, KP7, KP8, KP9,
    MOVE, ORDER, START, SELECTUNIT, TIDY, MENUSELECT, SCROLL, SELECT,
    SAVEGAME, CONTINUEGAME
};

#ifdef ALLEGRO4
class Al4UI;
typedef Al4UI UI;
#include "allegro4/Al4UI.hpp"
#else
class Al5UI;
typedef Al5UI UI;
#include "allegro5/Al5UI.hpp"
#endif

#endif // UI_HPP
