/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "Magician.hpp"

Magician::Magician(Coordinates opos, PLAYER player){
    type = MAGICIAN;
    sight = 4;
    speed = 2;
    hp = 15;
    maxhp = 20;
    init(opos, player);
    summonpos = pos;
}

Spirit* Magician::summonSpirit() {
    Spirit* sprt;

    updateSummonPos();

    if (summonpos == pos) {
        changeHp(5);
    } else {
        if (map->getTerrain(summonpos) == GRASS ){
            sprt = new Spirit(summonpos, owner);
            sprt->setMap(map);
            return sprt;
        }
    }
    return NULL;
}

void Magician::updateSummonPos() {
    if (!way.empty()) {
        summonpos = way.back();
        if ( pos.distanceTo(summonpos) > 3 ) {
            summonpos = way[2];
        }
    } else {
        summonpos = pos;
    }
}

const Coordinates& Magician::getSummonPos() {
    return summonpos;
}
