/* Hexwars - A Hexagonal Turn Based Strategy Game
 * Copyright (C) 2009-2011  Patrik Schönfeldt
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "TerraFormer.hpp"

TerraFormer::TerraFormer(Coordinates opos, PLAYER player){
    type  = TERRAFORMER;
    sight = 2;
    speed = 2;
    hp = 20;
    maxhp = 25;
    init(opos, player);
}

void TerraFormer::move(unsigned int time) {
    if (way.size() > 0) {
        for (unsigned int i = 100; i <= speed*100; i+=100) {
            /* time runs from 1 to 100, the folowing
             * equation simulates constant movement
             * of all units (slow and fast ones)
             */
            if ((i / (speed + 1)) == time) {
                oldway.push_back(pos);
                pos = way.front();
                way.erase(way.begin());
                if(map->getTerrain(pos) == WATER){
                    terraForm();
                }
                return;
            }
        }
    }
    return;
}

void TerraFormer::terraForm(){
    /* this check is needed because of the
     * Unit-Fighting-Test, TerraFormers should
     * know the map while playing */
    if (map != NULL){
        if(map->getTerrain(pos) == WATER){
            map->setHeight(pos, map->getHeight(pos)+1);
            kill();
        } else{
            map->setHeight(pos, map->getHeight(pos)-1);
            kill();
        }
    }
}
